const ticket_settings_edit = (wpsgSettings, admin_url, init_data) => {

	import(`${wpsgSettings.baseUrl}mods/mod_ticket/assets/js/vue.esm-browser.js`).then((module) => {

		 const { ref, createApp, onMounted } = module;

		createApp({
			setup() {

				const data = ref(init_data);
				const template = ref(undefined);
				const loading = ref(false);
				const file_upload = ref(undefined);

				const xhr = (action, param, callback_ok) => {

					param['action'] = action;

					const request = new XMLHttpRequest();

					request.open('POST', admin_url + '?action=wpsg_ticket', true);
					request.setRequestHeader('Content-Type', 'application/json; charset=UTF-8');

					request.onreadystatechange = () => {

						if (request.readyState === 4 && request.status === 200) {

							callback_ok(JSON.parse(request.responseText));

						}

					};

					request.send(JSON.stringify(param));

				};

				const uploadBg = (event) => {

					const upload_file = file_upload.value.files[0];

					const reader = new FileReader();

					reader.onload = function(event) {

						const base64Data = event.target.result.split(',')[1];

						const file = {
						  fileData: base64Data,
						  fileType: upload_file.type,
						  fileName: upload_file.name
						};

						loading.value = true;

						xhr('uploadBg', {
							template: template.value,
							file: file
						}, (response) => {

							file_upload.value.value = '';

							for (let i in data.value.arTemplates) {

								if (data.value.arTemplates[i].id == response.template.id) {

									data.value.arTemplates[i] = response.template;
									template.value = data.value.arTemplates[i];

								}

							}

							loading.value = false;

						});

					};

					reader.readAsDataURL(upload_file);

				};

				const addTemplate = () => {

					const template_name = window.prompt(data.value.label.newTemplate, '');

					if (template_name === '') { alert(data.value.label.error_noTemplateName); return; }

					loading.value = true;

					xhr('addTemplate', {
						template_name: template_name
					}, (response) => {

						loading.value = false;
						data.value.arTemplates.push(response.template);
						template.value = response.template;

					});

				};

				const removeTemplate = () => {

				}

				const setDefaultTemplate = () => {

				}

				const copyTemplate = () => {

					if (!confirm(data.value.label.copyTemplateConfirm)) return false;

					let new_template = JSON.parse(JSON.stringify(template.value));

					new_template.id = 0;
					new_template.template_name += ' (Kopie)';

					data.value.arTemplates.push(new_template);
					template.value = new_template;

				};

				const addField = (field_index) => {

					template.value.config.arField.splice(field_index, 0,  {
						id: 0, x: 0, y:0, align:'L', color:'000000', alpha:'1', angle:'0', fontsize:22, opaque:100,
						text: '', font: 'times.php'
					})

				}

				const removeField = (field_index) => {

					if (!confirm(data.value.label.removeFieldConfirm)) return;

					template.value.config.arField.splice(field_index, 1);

				}

				onMounted(() => {

					const el_select_modul_activ = document.getElementById('aktiv');
					const el_wpsg_ticket_modul = document.getElementById('wpsg_ticket_modul');

					el_select_modul_activ.addEventListener('change', event => {

						if (event.target.value === '1') {

							el_wpsg_ticket_modul.style.display = 'block';

						} else {

							el_wpsg_ticket_modul.style.display = 'none';

						}

					});

					document.querySelector('p.submit input[type="submit"]').addEventListener('click', (event) => {

						if (el_select_modul_activ.value === '0') return;

						event.preventDefault();

						loading.value = true;

						const wpsg_mod_ticket_orderstate_send = [];
						const selectElement_send = document.getElementById('wpsg_mod_ticket_orderstate_send');

						for (let i = 0; i < selectElement_send.options.length; i++) {

							if (selectElement_send.options[i].selected) {

								wpsg_mod_ticket_orderstate_send.push(selectElement_send.options[i].value);

							}

						}

						const wpsg_mod_ticket_orderstate_active = [];
						const selectElement_active = document.getElementById('wpsg_mod_ticket_orderstate_active');

						for (let i = 0; i < selectElement_active.options.length; i++) {

							if (selectElement_active.options[i].selected) {

								wpsg_mod_ticket_orderstate_active.push(selectElement_active.options[i].value);

							}

						}

						xhr('saveSettings', {
							'wpsg_mod_ticket_orderstate_send': wpsg_mod_ticket_orderstate_send,
							'wpsg_mod_ticket_orderstate_active': wpsg_mod_ticket_orderstate_active,
							'arTemplates': data.value.arTemplates
						}, (response) => {

							loading.value = false;

						});

					})

				});

				return {
					data, template, loading, file_upload,
					addTemplate, uploadBg, removeTemplate, setDefaultTemplate, addField, removeField, copyTemplate
				}

			}
		}).mount('#wpsg_ticket_modul');

	});

}

export { ticket_settings_edit as ticket_settings_edit }