const product_addedit_content = async (wpsgSettings, product_id, admin_url) => {

	const { ref, createApp, onMounted, watch } = await import(`${wpsgSettings.baseUrl}mods/mod_ticket/assets/js/vue.esm-browser.js`);
	const { default: VanillaCalendar } = await import(`${wpsgSettings.baseUrl}mods/mod_ticket/assets/vanilla-calendar/vanilla-calendar.min.m.js`);

	createApp({
		setup() {

			const dialog_add = ref(undefined);
			const serial = ref(undefined);
			const mounted = ref(false);
			const loading = ref(false);
			const data = ref({
				pager: {
					page: undefined,
					per_page: 25,
					pages: undefined,
					count: undefined
				},
				filter: {
					hideInactive: true,
					autoticket_id: 0,
					product_id: product_id
				},
				items: []
			});
			const data_serial = ref({
				pager: {
					page: undefined,
					per_page: 1,
					pages: undefined,
					count: undefined
				},
				filter: {
					product_id: product_id
				},
				items: []
			});
			const tab = ref(2);
			const ref_calendar = ref(undefined);
			const calendar = ref(undefined);
			const cal_loading = ref(false);
			const arOccupancy = ref(undefined);
			const day_selected = ref(undefined);

			const closeDialog = () => {

				dialog_add.value = undefined;

			}
			const addEvent = () => {

				dialog_add.value = {
					from_date: '0000-00-00',
					from_time: '00:00',
					to_date: '0000-00-00',
					to_time: '00:00',
					slots: 1
				};

			}
			const setWeekDay = (event, i) => {

				if (!serial.value.days.includes(i)) serial.value.days.push(i);
				else {

					const index = serial.value.days.indexOf(i);
					serial.value.days.splice(index, 1);

				}

			};
			const addSerialevent = () => {

				serial.value = {
					id: 0,
					from_date: null,
					to_date: null,
					days_future: 30,
					days: [0,1,2,3,4],
					event_data: {
						from_time: '00:00',
						to_time: '00:00',
						slots: 1
					}
				}

			}

			const closeSerialDialog = () => {

				serial.value = undefined;

			}

			const submitSerial = () => {

				xhr('save_tickets', {
					'serial': serial.value
				}, (response) => {

					serial.value = undefined;
					load();

				});

			}

			const xhr = (action, param, callback_ok) => {

				param['action'] = action;
				param['product_id'] = product_id;

				const request = new XMLHttpRequest();

				request.open('POST', admin_url + '?action=wpsg_ticket', true);
				request.setRequestHeader('Content-Type', 'application/json; charset=UTF-8');

				request.onreadystatechange = () => {

					if (request.readyState === 4 && request.status === 200) {

						callback_ok(JSON.parse(request.responseText));

					}

				};

				request.send(JSON.stringify(param));

			};

			const changeTerminState = (ticket) => {

				loading.value = true;

				xhr('changeState', {
					ticket_id: ticket.id
				}, (response) => {

					reload();

				});

			};

			const editTicket = (ticket) => {

				serial.value = {
					id: ticket.id,
					label: ticket.label,
					label_short: ticket.label_short,
					from_date: ticket.autoticket.from_date,
					to_date: ticket.autoticket.to_date,
					days_future: ticket.autoticket.days_future,
					days: ticket.autoticket.days,
					event_data: ticket.autoticket.event_data
				}
			};

			const deleteTicket = (ticket) => {

				if (!confirm('Sind Sie sich sicher?')) return;

				loading.value = true;

				xhr('deleteTicket', {
					ticket_id: ticket.id
				}, (response) => {

					reload();

				});

			};

			const reload = () => {

				const load_page = data.value.pager.page;

				data.value.pager.page = 0;
				goPage(load_page);

			}

			const goSerialPage = (page) => {
				
				if (page < 1 || page > data_serial.value.pager.pages) page = 1;
				if (page === data_serial.value.pager.page) return false;

				data_serial.value.pager.page = page;

				load();

			}
			
			const goPage = (page) => {

				if (page < 1 || page > data.value.pager.pages) page = 1;
				if (page === data.value.pager.page) return false;

				data.value.pager.page = page;

				load();

			}

			const load = () => {

				loading.value = true;

				xhr('getTicket', {
					'filter': data.value.filter,
					'pager': data.value.pager,
					'pager_serial': data_serial.value.pager,
					'filter_serial': data_serial.value.filter
				}, (response) => {

					data.value.items = response.items;
					data.value.pager = response.pager;

					data_serial.value.items = response.items_serial;
					data_serial.value.pager = response.pager_serial;

					loading.value = false;

				});

			}

			const dialog_submit = (event) => {

				event.preventDefault();

				const data = dialog_add.value;

				if (
					(data.from_time === '00:00' && data.to_time !== '00:00') ||
					(data.from_time !== '00:00' && data.to_time === '00:00')
				) {

					alert('Bitte keine Zeit oder beide Zeiten angeben.');

					return;

				}

				dialog_add.value = undefined;
				loading.value = true;

				xhr('add_tickets', {
					'product_id': product_id,
					'data': data
				}, (response) => {

					reload();

				});

			};

			const display_autoTermin = (autotermin_id) => {

				tab.value = 1;
				data.value.filter.autoticket_id = autotermin_id;
				load();

			}

			onMounted(() => {

				mounted.value = true;

				goPage(1);

			});

			watch(ref_calendar, (newValue, oldValue) => {

				if (newValue !== null) {

					cal_loading.value = true;

					xhr('loadOccupancy', { }, (response) => {

						arOccupancy.value = response.arOccupancy;

						let popups = {};

						Object.keys(response.arOccupancy).forEach(k => {

							if (response.arOccupancy[k] !== null) {

								popups[k] = {
									modifier: ((response.arOccupancy[k].slots === response.arOccupancy[k].slots_used) ? 'full' : '')
								}

							}

						});

						calendar.value = new VanillaCalendar(ref_calendar.value, {
							'popups': popups,
							'settings': {
								'visibility': {
									'theme': 'light',
								},
								'lang': 'de',
								'range': {
									'disableAllDays': true,
									'enabled': Object.keys(response.arOccupancy)
								},
								'selection': {
									'day': 'single'
								}
							},
							actions: {
								clickDay(e, dates) {

									if (dates.length === 1) day_selected.value = dates[0];
									else day_selected.value = undefined;

								}
							},
						});

						calendar.value.init();

						cal_loading.value = false;

					});

				}

			});

			return {
				dialog_add, mounted, loading, data, data_serial, tab, ref_calendar, cal_loading, arOccupancy, day_selected, serial,
				addEvent, closeDialog, dialog_submit, goPage, changeTerminState, editTicket, deleteTicket, reload, addSerialevent, submitSerial, closeSerialDialog, setWeekDay, goSerialPage, load, display_autoTermin
			};

		}
	}).mount('#wpsg_ticket_product');

};

export { product_addedit_content as product_addedit_content }