<?php
	
	declare(strict_types=1);
	
	/**
	 * @author: daniel
	 * @date: 22.08.24
	 * @time: 11:13
	 */
	 
	class wpsg_mod_ticket extends \wpsg_mod_basic {
		
		private static bool $init = false;
		
		var $lizenz = 1;
		var $id = 5502;
		var $hilfeURL = '';
		//var $version = "9.9.9";
		//var $free = false;
		
		public function __construct() {
			
			parent::__construct();
			
			$this->name = __('Ticketprodukte', 'wpsg');
			$this->group = __('Produkte', 'wpsg');
			$this->desc = __('', 'wpsg');
			
		}
		
		public function init(): void {
			
			global $wpdb;
			
			if (self::$init === false) {
				
				define('WPSG_TBL_TICKETS', $wpdb->prefix.'wpsg_tickets');
				define('WPSG_TBL_TICKET_TEMPLATES', $wpdb->prefix.'wpsg_ticket_templates');
				
				\spl_autoload_register(function($class_name) {

					$arPath = explode('\\', $class_name);
			
					if ($arPath[0] === 'wpsgTicket') {
			
						$file_path = implode(DIRECTORY_SEPARATOR, [dirname(__FILE__), 'mod_ticket', 'classes', ucfirst($arPath[1]).'.php']);
						
						if (file_exists($file_path)) {
			
							require_once($file_path);
			
						} else {
							
							throw new \Exception(wpsg_translate(__('Klasse #1# für TicketProdukt Modul nicht gefunden.', 'wpsg'), $file_path));
							
						}
			
					}
			
				} );
	 
				\add_action('wp_ajax_wpsg_ticket', ['\wpsgTicket\Ajax', 'backend']);
				\add_action('wp_ajax_wpsg_ticket_frontend', ['\wpsgTicket\Ajax', 'frontend']);
				\add_action('wp_ajax_nopriv_wpsg_ticket_frontend', ['\wpsgTicket\Ajax', 'frontend']);
				
				\add_action('wpsg_produkt_edit', ['\wpsgTicket\Action', 'wpsg_produkt_edit']);
				\add_action('wpsg_product_addedit_content', ['wpsgTicket\Action', 'wpsg_product_addedit_content']);
				\add_action('wpsg_renderProdukt_templateSelect', ['\wpsgTicket\Action', 'wpsg_renderProdukt_templateSelect']);
				\add_action('wpsg_basket_row', ['\wpsgTicket\Action', 'wpsg_basket_row']);
				\add_action('wpsg_overview_row', ['\wpsgTicket\Action', 'wpsg_overview_row']);
				\add_action('wpsg_calculation_saveProduct_after', ['\wpsgTicket\Action', 'wpsg_calculation_saveProduct_after']);
				\add_action('wpsg_setOrderStatus', ['\wpsgTicket\Action', 'setOrderStatus']);
				\add_action('wpsg_basket_updateProduktFromSession', ['\wpsgTicket\Action', 'basket_updateProduktFromSession']);
				\add_action('wpsg_calculation_addProduct', ['\wpsgTicket\Action', 'wpsg_calculation_addProduct']);
				\add_action('wpsg_order_view_row', ['\wpsgTicket\Action', 'wpsg_order_view_row']);
				\add_action('wpsg_admin_emailconf', ['\wpsgTicket\Action', 'wpsg_admin_emailconf']);
				\add_action('wpsg_admin_emailconf_save', ['\wpsgTicket\Action', 'wpsg_admin_emailconf_save']);
				\add_action('wpsg_order_view', ['\wpsgTicket\Action', 'order_view']);
				\add_action('admin_menu', ['\wpsgTicket\Action', 'admin_menu']);
				
				\add_action('wp_enqueue_scripts', function() {
 
				
					
				});
				\add_action('admin_enqueue_scripts', function() {
				
					if (($_REQUEST['page']??'') === 'wpsg-Produkt') {
						
						\wp_enqueue_style('vanilla-calendar', WPSG_URL.'mods/mod_ticket/assets/vanilla-calendar/vanilla-calendar.min.css');
						\wp_enqueue_style('light-theme', WPSG_URL.'mods/mod_ticket/assets/vanilla-calendar/themes/light.min.css');
						\wp_enqueue_style('dark-theme', WPSG_URL.'mods/mod_ticket/assets/vanilla-calendar/themes/dark.min.css');
						
					}
				
				});
				\add_action('wp_footer', function() {
					
					if (\wpsgTicket\TicketProduct::$enqueTicket === true) {
						
						\wp_enqueue_style('vanilla-calendar', WPSG_URL.'mods/mod_ticket/assets/vanilla-calendar/vanilla-calendar.min.css');
						\wp_enqueue_style('light-theme', WPSG_URL.'mods/mod_ticket/assets/vanilla-calendar/themes/light.min.css');
						\wp_enqueue_style('dark-theme', WPSG_URL.'mods/mod_ticket/assets/vanilla-calendar/themes/dark.min.css');
						\wp_enqueue_style('wpsg_ticket-frontend', WPSG_URL.'mods/mod_ticket/assets/css/wpsg_ticket.css');
						\wp_enqueue_style('wpsg_ticket-calendar', WPSG_URL.'mods/mod_ticket/assets/css/wpsg_calendar.css');
						
						\wp_enqueue_script('vanilla-calendar', WPSG_URL.'mods/mod_ticket/assets/vanilla-calendar/vanilla-calendar.min.js', array(), '', true);
						\wp_enqueue_script('wpsg_vue3', WPSG_URL.'mods/mod_ticket/assets/js/vue3.3.6.global.js', array(), '', true);
						\wp_enqueue_script('wpsg_ticket-frontend', WPSG_URL.'mods/mod_ticket//assets/js/wpsg_ticket_frontend.js', ['wpsg_vue3', 'vanilla-calendar'], '', true);
						
						\wp_enqueue_script('wpsg_ticket_fullcalendar', WPSG_URL.'mods/mod_ticket/assets/vanilla-calendar/index.global.min.js', [], '1.0', true);
					 	\wp_enqueue_script('wpsg_ticket_fullcalendar_de', WPSG_URL.'mods/mod_ticket/assets/vanilla-calendar/locales-all.global.min.js', [], '1.0', true);
						
					}
					
				});
				
				if (!\wp_next_scheduled('wpsg_ticket_daily')) {

					\wp_schedule_event(time(), 'daily', 'wpsg_ticket_daily');
			
				}
				
				\add_action('wpsg_ticket_daily', ['\wpsgTicket\Action', 'cronDaily']);
				
				self::$init = true;
				
			}
			
		}
		
		public function settings_edit(): void {
		
			$font_path = WPSG_PATH_LIB.'FPDF_1.81/font/';

	        $arFontFiles = scandir($font_path);

	        foreach ($arFontFiles as $k => $v) {

	            $file = $font_path.$v;

	            if (is_file($file) && file_exists($file) && preg_match('/(.*)\.php$/i', $v)) {

	                $this->shop->view['arFonts'][$v] = ucfirst(preg_replace('/\.php$/i', '', $v));

	            }

	        }
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_ticket/settings_edit.phtml');
		
		}
		
		public function settings_save(): void {
		
		}
		
		public function install(): void {
			
			global $wpdb;
			
			$charset_collate = $wpdb->get_charset_collate();
			
			$sql = "CREATE TABLE ".$wpdb->prefix."wpsg_tickets (
				id INT NOT NULL AUTO_INCREMENT,
				label VARCHAR(500) DEFAULT '' NOT NULL,
				label_short VARCHAR(500) DEFAULT '' NOT NULL,
				p_id INT NOT NULL,
				from_date DATE,
				from_time TIME,
				to_date DATE,
				to_time TIME,
				slots INT,
				state INT DEFAULT 0,
				autoticket TEXT DEFAULT NULL,
				autoticket_id INT(11) DEFAULT 0 NULL,
				PRIMARY KEY  (id),
				KEY autoticket_id (autoticket_id),
				KEY p_id (p_id)
			) $charset_collate;";
			
			require_once(ABSPATH.'wp-admin/includes/upgrade.php');

			dbDelta($sql);
			
			$sql = "CREATE TABLE ".$wpdb->prefix."wpsg_ticket_templates (
				id INT NOT NULL AUTO_INCREMENT,
				config BLOB,
				template_name VARCHAR(500) NOT NULL DEFAULT '',
				defaulttemplate INT(1) NOT NULL DEFAULT 0,
				deleted INT NOT NULL DEFAULT 0,
				PRIMARY KEY  (id)
			) $charset_collate;";
			
			dbDelta($sql);
			
			$sql = "CREATE TABLE ".$wpdb->prefix."wpsg_ticket_booking (
				id INT NOT NULL AUTO_INCREMENT,
				booking_key VARCHAR(255) NOT NULL,
				order_id INT NOT NULL,
				order_product_id INT NOT NULL,
				product_id INT NOT NULL,
				ticket_id INT NOT NULL,
				amount_index INT NOT NULL,
				revoke_user INT(11) NULL DEFAULT NULL,
				revoke_time DATETIME NULL DEFAULT NULL,
				send_user INT(11) NOT NULL DEFAULT 0,
				send_time DATETIME NULL DEFAULT NULL,
				PRIMARY KEY  (id),
				KEY booking_key (booking_key),
				KEY order_id (order_id),
				KEY order_product_id (order_product_id),
				KEY product_id (product_id),
				KEY ticket_id (ticket_id),
				KEY amount_index (amount_index)
			) $charset_collate;";
			
			dbDelta($sql);
			
			$sql = "CREATE TABLE ".$wpdb->prefix."wpsg_ticket_log (
				id INT NOT NULL AUTO_INCREMENT,
				booking_id INT(11) NOT NULL,
				user_id INT(11) NOT NULL,
				date_time DATETIME NOT NULL,
				log INT(11) NOT NULL,
				PRIMARY KEY  (id),
				KEY booking_id (booking_id)
			) $charset_collate;";
			
			dbDelta($sql);
			
			\wpsg_ShopController::getShop()->checkDefault('wpsg_mod_ticket_orderstate_active', '100,110');
			\wpsg_ShopController::getShop()->checkDefault('wpsg_mod_ticket_orderstate_send', '100');
			\wpsg_ShopController::getShop()->checkDefault('wpsg_ticketmail_betreff', 'Ihre Tickets');
			
		}
		
	}